AchSnd.Text={
Title = "Achievement Sounds",
TitleSub = "Set Add On config options below",
Enable = "Enable the Add On to function",
Guild = "Enable on guild member achievements",
Party = "Enable on party member achievements",
Near  = "Enable for people near you's achievements",
MSBT  = "Enable output to MSBT's notification frame",
Popup = "Enable Grats popup for 1-click gratting",
Sound = "Enable sound to notify you of an achievement",
Timeout = "Set the pop up's timeout",
Random = "Display a random grats message(checked) or default message",
DefaultMsg = "The message displayed if Random is off"
}


local waitTable = {};
local waitFrame = nil;
AchSnd.ConfigLoaded = 0

function AchSnd_wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end


AchSnd.Checkclick = function()
	PlaySound("GAMEGENERICBUTTONPRESS")
end

AchSnd.Slideclick = function()
	if (AchSnd.ConfigLoaded == 0) then
		AchSnd_wait(1, AchSnd.Init)
		AchSnd.ConfigLoaded = 1
	end
	AchSnd.panel.Timeout.Val:SetNumber( AchSnd.panel.Timeout:GetValue() )
	PlaySound("GAMEGENERICBUTTONPRESS")
end

--Panel
AchSnd.panel = CreateFrame( "Frame", "AchSndConfig", UIParent )
local me = AchSnd.panel
me.name = "Ach. Sounds"

local X = 16
local Y = 26
-- Pane title
local Title = me:CreateFontString( nil, "ARTWORK", "GameFontNormalLarge" )
Title:SetPoint( "TOPLEFT", 16, -16 )
Title:SetText( AchSnd.Text.Title )
local SubText = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
SubText:SetPoint( "TOPLEFT", Title, "BOTTOMLEFT", 0, -8 )
SubText:SetPoint( "RIGHT", -32, 0 )
SubText:SetHeight( 32 )
SubText:SetJustifyH( "LEFT" )
SubText:SetJustifyV( "TOP" )
SubText:SetText( AchSnd.Text.TitleSub )

me.Enable = CreateFrame( "CheckButton", "AchSndConfigEnableCheckbox", me, "InterfaceOptionsCheckButtonTemplate" )
	me.Enable:SetPoint("TOPLEFT", me ,"TOPLEFT", X, -Y*3 )
	me.Enable:SetSize( 26, 26 )
	me.Enable:SetScript( "OnClick", AchSnd.Checkclick )

me.Enable.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Enable.Text:SetPoint( "BOTTOMLEFT", me.Enable , "BOTTOMLEFT", X*2 , -13 )
	me.Enable.Text:SetPoint( "RIGHT", -32, 0 )
	me.Enable.Text:SetHeight( 32 )
	me.Enable.Text:SetJustifyH( "LEFT" )
	me.Enable.Text:SetJustifyV( "TOP" )
	me.Enable.Text:SetText( AchSnd.Text.Enable )
	
me.Guild = CreateFrame( "CheckButton", "AchSndConfigGuildCheckbox", me, "InterfaceOptionsCheckButtonTemplate" )
	me.Guild:SetPoint("TOPLEFT", me ,"TOPLEFT", X, -Y*4 )
	me.Guild:SetSize( 26, 26 )
	me.Guild:SetScript( "OnClick", AchSnd.Checkclick )

me.Guild.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Guild.Text:SetPoint( "BOTTOMLEFT", me.Guild , "BOTTOMLEFT", X*2 , -13 )
	me.Guild.Text:SetPoint( "RIGHT", -32, 0 )
	me.Guild.Text:SetHeight( 32 )
	me.Guild.Text:SetJustifyH( "LEFT" )
	me.Guild.Text:SetJustifyV( "TOP" )
	me.Guild.Text:SetText( AchSnd.Text.Guild )
	
me.Party = CreateFrame( "CheckButton", "AchSndConfigPartyCheckbox", me, "InterfaceOptionsCheckButtonTemplate" )
	me.Party:SetPoint("TOPLEFT", me ,"TOPLEFT", X, -Y*5 )
	me.Party:SetSize( 26, 26 )
	me.Party:SetScript( "OnClick", AchSnd.Checkclick )

me.Party.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Party.Text:SetPoint( "BOTTOMLEFT", me.Party , "BOTTOMLEFT", X*2 , -13 )
	me.Party.Text:SetPoint( "RIGHT", -32, 0 )
	me.Party.Text:SetHeight( 32 )
	me.Party.Text:SetJustifyH( "LEFT" )
	me.Party.Text:SetJustifyV( "TOP" )
	me.Party.Text:SetText( AchSnd.Text.Party )
	
me.Near = CreateFrame( "CheckButton", "AchSndConfigNearCheckbox", me, "InterfaceOptionsCheckButtonTemplate" )
	me.Near:SetPoint("TOPLEFT", me ,"TOPLEFT", X, -Y*6 )
	me.Near:SetSize( 26, 26 )
	me.Near:SetScript( "OnClick", AchSnd.Checkclick )

me.Near.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Near.Text:SetPoint( "BOTTOMLEFT", me.Near , "BOTTOMLEFT", X*2 , -13 )
	me.Near.Text:SetPoint( "RIGHT", -32, 0 )
	me.Near.Text:SetHeight( 32 )
	me.Near.Text:SetJustifyH( "LEFT" )
	me.Near.Text:SetJustifyV( "TOP" )
	me.Near.Text:SetText( AchSnd.Text.Near )

me.MSBT = CreateFrame( "CheckButton", "AchSndConfigMSBTCheckbox", me, "InterfaceOptionsCheckButtonTemplate" )
	me.MSBT:SetPoint("TOPLEFT", me ,"TOPLEFT", X, -Y*7 )
	me.MSBT:SetSize( 26, 26 )
	me.MSBT:SetScript( "OnClick", AchSnd.Checkclick )

me.MSBT.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.MSBT.Text:SetPoint( "BOTTOMLEFT", me.MSBT , "BOTTOMLEFT", X*2 , -13 )
	me.MSBT.Text:SetPoint( "RIGHT", -32, 0 )
	me.MSBT.Text:SetHeight( 32 )
	me.MSBT.Text:SetJustifyH( "LEFT" )
	me.MSBT.Text:SetJustifyV( "TOP" )
	me.MSBT.Text:SetText( AchSnd.Text.MSBT )

me.Popup = CreateFrame( "CheckButton", "AchSndConfigPopupCheckbox", me, "InterfaceOptionsCheckButtonTemplate" )
	me.Popup:SetPoint("TOPLEFT", me ,"TOPLEFT", X, -Y*8 )
	me.Popup:SetSize( 26, 26 )
	me.Popup:SetScript( "OnClick", AchSnd.Checkclick )

me.Popup.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Popup.Text:SetPoint( "BOTTOMLEFT", me.Popup , "BOTTOMLEFT", X*2 , -13 )
	me.Popup.Text:SetPoint( "RIGHT", -32, 0 )
	me.Popup.Text:SetHeight( 32 )
	me.Popup.Text:SetJustifyH( "LEFT" )
	me.Popup.Text:SetJustifyV( "TOP" )
	me.Popup.Text:SetText( AchSnd.Text.Popup )
	
me.Timeout = CreateFrame( "Slider", "AchSndConfigTimeoutSlider", me, "OptionsSliderTemplate" )
	me.Timeout:SetMinMaxValues( 0, 60 )
	me.Timeout:SetOrientation("HORIZONTAL")
	me.Timeout:SetPoint("TOPLEFT", me ,"TOPLEFT", X*3 , -Y*10 )
	me.Timeout:SetValueStep( 1 )
	me.Timeout:SetWidth( 240 )
	me.Timeout:SetHeight( 16 )
	me.Timeout:SetScript( "OnValueChanged", AchSnd.Slideclick )
	getglobal(me.Timeout:GetName() .. 'Low'):SetText('0'); --Sets the left-side slider text (default is "Low").
	getglobal(me.Timeout:GetName() .. 'High'):SetText('60'); --Sets the right-side slider text (default is "High").
	getglobal(me.Timeout:GetName() .. 'Text'):SetText(AchSnd.Text.Timeout); --Sets the "title" text (top-centre of slider).
	
me.Timeout.Val=CreateFrame("EditBox", "AchSndConfigTimeoutValue", me, "InputBoxTemplate")
	me.Timeout.Val:SetFontObject("ChatFontNormal")
	me.Timeout.Val:SetTextInsets(0, 0, 3, 3)
	me.Timeout.Val:SetPoint("BOTTOMRIGHT", me.Timeout , "BOTTOMLEFT", -16 , -8)
	me.Timeout.Val:SetPoint("RIGHT", -32, 0)
	me.Timeout.Val:SetHeight(19)
	me.Timeout.Val:SetWidth(32)
	me.Timeout.Val:SetNumeric(true)
	me.Timeout.Val:SetAutoFocus(false)
	me.Timeout.Val:SetMaxLetters( 2 )
	me.Timeout.Val:SetScript("OnEnterPressed" , function(self)
		local value = me.Timeout.Val:GetNumber()
		if (value >= 0 and value <= 60) then
			me.Timeout:SetValue( value )
			return
		end
		me.Timeout.Val:SetNumber( me.Timeout:GetValue() )
	end)
	
	me.Timeout.Val:SetScript("OnEscapePressed", function(self)
		me.Timeout.Val:SetNumber( me.Timeout:GetValue() )
		me.Timeout.Val:ClearFocus()
	end)
	
me.Sound = CreateFrame( "CheckButton", "AchSndConfigSoundCheckbox", me, "InterfaceOptionsCheckButtonTemplate" )
	me.Sound:SetPoint("TOPLEFT", me ,"TOPLEFT", X, -Y*11 )
	me.Sound:SetSize( 26, 26 )
	me.Sound:SetScript( "OnClick", AchSnd.Checkclick )

me.Sound.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Sound.Text:SetPoint( "BOTTOMLEFT", me.Sound , "BOTTOMLEFT", X*2 , -13 )
	me.Sound.Text:SetPoint( "RIGHT", -32, 0 )
	me.Sound.Text:SetHeight( 32 )
	me.Sound.Text:SetJustifyH( "LEFT" )
	me.Sound.Text:SetJustifyV( "TOP" )
	me.Sound.Text:SetText( AchSnd.Text.Sound )

me.Random = CreateFrame( "CheckButton", "AchSndConfigRandomCheckbox", me, "InterfaceOptionsCheckButtonTemplate" )
	me.Random:SetPoint("TOPLEFT", me ,"TOPLEFT", X, -Y*12 )
	me.Random:SetSize( 26, 26 )
	me.Random:SetScript( "OnClick", AchSnd.Checkclick )

me.Random.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Random.Text:SetPoint( "BOTTOMLEFT", me.Random , "BOTTOMLEFT", X*2 , -13 )
	me.Random.Text:SetPoint( "RIGHT", -32, 0 )
	me.Random.Text:SetHeight( 32 )
	me.Random.Text:SetJustifyH( "LEFT" )
	me.Random.Text:SetJustifyV( "TOP" )
	me.Random.Text:SetText( AchSnd.Text.Random )

me.Default = CreateFrame( "EditBox", "AchSndConfigDefaultMsgEditbox", me, "InputBoxTemplate" )
	me.Default:SetFontObject("ChatFontNormal")
	me.Default:SetTextInsets(0, 0, 3, 3)
	me.Default:SetPoint("TOPLEFT", me , "TOPLEFT", X ,-Y*14)
	me.Default:SetPoint("RIGHT", -32, 0)
	me.Default:SetHeight(19)
	me.Default:SetWidth(50)
	me.Default:SetAutoFocus(false)
	me.Default:SetMaxLetters( 254 )

	me.Default:SetScript("OnEnterPressed" , function(self)
		me.Default:ClearFocus()
	end)
	
	me.Default:SetScript("OnEscapePressed", function(self)
		me.Default:SetText( AchSnd_Settings.DefaultMsg )
		me.Default:ClearFocus()
	end)


me.Default.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Default.Text:SetPoint( "BOTTOMLEFT", me.Default , "BOTTOMLEFT", 0 , .25 * Y )
	me.Default.Text:SetPoint( "RIGHT", -32, 0 )
	me.Default.Text:SetHeight( 32 )
	me.Default.Text:SetJustifyH( "LEFT" )
	me.Default.Text:SetJustifyV( "TOP" )
	me.Default.Text:SetText( AchSnd.Text.DefaultMsg )


AchSnd.Init = function(...)
	local setting = AchSnd_Settings
	local me = AchSnd.panel
	me.Enable:SetChecked( setting.Enable == "on")
	me.Guild:SetChecked( setting.Guild == "on")
	me.Party:SetChecked( setting.Party == "on")
	me.Near:SetChecked( setting.Near == "on")
	me.MSBT:SetChecked( setting.MSBT == "on")
	me.Popup:SetChecked( setting.Popup == "on")
	me.Timeout:SetValue( setting.Timeout)
	me.Timeout.Val:SetCursorPosition( 0 )
	me.Timeout.Val:SetNumber( setting.Timeout )
	me.Sound:SetChecked( setting.Sound == "on")
	me.Random:SetChecked( setting.Random == "on")
	me.Default:SetCursorPosition( 0 )
	me.Default:SetText( setting.DefaultMsg )

end

AchSnd.Reset = function(...)
	local def = AchSnd_Defaults
	local cur = AchSnd_Settings
	
	cur.Enable = def.Enable
	cur.Guild = def.Guild
	cur.Party = def.Party
	cur.Near = def.Near
	cur.MSBT = def.MSBT
	cur.Popup = def.Popup
	cur.Timeout = def.Timeout
	cur.Sound = def.Sound
	cur.Random = def.Random
	cur.DefaultMsg = def.DefaultMsg
	AchSnd.Init()
end


me.refresh = function(self)
	AchSnd.Init()
end

me.default = function (self)
	AchSnd.Reset()
end

me.cancel = function (self)
	AchSnd.Init()
end

me.okay = function(self)
	local setting = AchSnd_Settings
	local me = AchSnd.panel
	-- Enable CheckBox
	if (me.Enable:GetChecked() and setting.Enable == "off" ) then
		setting.Enable = "on"
	end
	if ( not(me.Enable:GetChecked()) and setting.Enable == "on") then
		setting.Enable = "off"
	end

	-- Guild CheckBox
	if (me.Guild:GetChecked() and setting.Guild == "off") then
		setting.Guild = "on"
	end
	if ( not(me.Guild:GetChecked()) and setting.Guild == "on") then
		setting.Guild = "off"
	end
	
	-- Party CheckBox
	if (me.Party:GetChecked() and setting.Party == "off") then
		setting.Party = "on"
	end
	if ( not(me.Party:GetChecked()) and setting.Party == "on") then
		setting.Party = "off"
	end

	-- Near CheckBox
	if (me.Near:GetChecked() and setting.Near == "off") then
		setting.Near = "on"
	end
	if ( not(me.Near:GetChecked()) and setting.Near == "on") then
		setting.Near = "off"
	end

	-- MSBT CheckBox
	if (me.MSBT:GetChecked() and setting.MSBT == "off") then
		setting.MSBT = "on"
	end
	if ( not(me.MSBT:GetChecked()) and setting.MSBT == "on") then
		setting.MSBT = "off"
	end
	
	-- Popup CheckBox
	if (me.Popup:GetChecked() and setting.Popup == "off") then
		setting.Popup = "on"
	end
	if ( not(me.Popup:GetChecked()) and setting.Popup == "on") then
		setting.Popup = "off"
	end

	-- Timeout Slider
	if (me.Timeout:GetValue() ~= setting.Timeout) then
		setting.Timeout = me.Timeout:GetValue()
	end

	-- Sound CheckBox
	if (me.Sound:GetChecked() and setting.Sound == "off") then
		setting.Sound = "on"
	end
	if ( not(me.Sound:GetChecked()) and setting.Sound == "on") then
		setting.Sound = "off"
	end
	
	-- Random Message Enable CheckBox
	if (me.Random:GetChecked() and setting.Random == "off") then
		setting.Random = "on"
	end
	if ( not(me.Random:GetChecked()) and setting.Random == "on") then
		setting.Random = "off"
	end
	
	-- Default Message EditBox
	if (me.Default:GetText() ~= setting.DefaultMsg) then
		setting.DefaultMsg = me.Default:GetText()
	end
	
end

InterfaceOptions_AddCategory( me )


